(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('intl-tel-input'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('intl-tel-input-ng', ['exports', '@angular/core', '@angular/forms', 'intl-tel-input', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['intl-tel-input-ng'] = {}, global.ng.core, global.ng.forms, global.intlTelInput, global.ng.common));
}(this, (function (exports, i0, i2, intlTelInput, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var intlTelInput__namespace = /*#__PURE__*/_interopNamespace(intlTelInput);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /*
     * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
     * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
     * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
     * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
     * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
     * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
     */
    var IntlTelInputComponent = /** @class */ (function () {
        function IntlTelInputComponent() {
            this.name = 'intl-tel-input-name';
            this.options = {};
            this.E164PhoneNumberChange = new i0.EventEmitter();
        }
        IntlTelInputComponent.modifyCountryData = function () {
            window.intlTelInputGlobals.getCountryData().forEach(function (country) { return country.name = country.name.replace(/.+\((.+)\)/, '$1'); });
        };
        IntlTelInputComponent.prototype.ngAfterViewInit = function () {
            if (this.onlyLocalized) {
                IntlTelInputComponent.modifyCountryData();
            }
            var intlTelInputInstance = intlTelInput__namespace;
            this._intlTelInput = intlTelInputInstance(this._inputElement.nativeElement, this.options);
        };
        Object.defineProperty(IntlTelInputComponent.prototype, "intlTelInput", {
            get: function () {
                return this._intlTelInput;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IntlTelInputComponent.prototype, "phoneNumber", {
            get: function () {
                return this._phoneNumber;
            },
            set: function (value) {
                if (!!value) {
                    this._intlTelInput.setNumber(value);
                }
                this._phoneNumber = value;
                this.i18nizePhoneNumber();
            },
            enumerable: false,
            configurable: true
        });
        IntlTelInputComponent.prototype.i18nizePhoneNumber = function () {
            this.E164PhoneNumber = null;
            if (this._intlTelInput.isValidNumber()) {
                this.E164PhoneNumber = this._intlTelInput.getNumber();
            }
            this.E164PhoneNumberChange.emit(this.E164PhoneNumber);
        };
        return IntlTelInputComponent;
    }());
    IntlTelInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: IntlTelInputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    IntlTelInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.0", type: IntlTelInputComponent, selector: "intl-tel-input", inputs: { cssClass: "cssClass", E164PhoneNumber: "E164PhoneNumber", label: "label", labelCssClass: "labelCssClass", name: "name", onlyLocalized: "onlyLocalized", options: "options", required: "required" }, outputs: { E164PhoneNumberChange: "E164PhoneNumberChange" }, viewQueries: [{ propertyName: "_inputElement", first: true, predicate: ["intlTelInput"], descendants: true }], ngImport: i0__namespace, template: "<label [attr.for]=\"name\" [ngClass]=\"labelCssClass\" *ngIf=\"label && name\" >{{label}}</label>\n<input\n    type=\"text\"\n    [ngClass]=\"cssClass\"\n    [attr.id]=\"name\"\n    [attr.name]=\"name\"\n    [name]=\"name\"\n    [attr.aria-required]=\"required || null\"\n    [required]=\"required\"\n    [(ngModel)]=\"phoneNumber\"\n    (countrychange)=\"i18nizePhoneNumber()\"\n    #intlTelInput>\n\n", styles: [""], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2__namespace.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i2__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }], viewProviders: [{ provide: i2.ControlContainer, useExisting: i2.NgForm }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: IntlTelInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'intl-tel-input',
                        templateUrl: './intl-tel-input.component.html',
                        styleUrls: ['./intl-tel-input.component.scss'],
                        viewProviders: [{ provide: i2.ControlContainer, useExisting: i2.NgForm }]
                    }]
            }], propDecorators: { cssClass: [{
                    type: i0.Input
                }], E164PhoneNumber: [{
                    type: i0.Input
                }], label: [{
                    type: i0.Input
                }], labelCssClass: [{
                    type: i0.Input
                }], name: [{
                    type: i0.Input
                }], onlyLocalized: [{
                    type: i0.Input
                }], options: [{
                    type: i0.Input
                }], required: [{
                    type: i0.Input
                }], E164PhoneNumberChange: [{
                    type: i0.Output
                }], _inputElement: [{
                    type: i0.ViewChild,
                    args: ['intlTelInput']
                }] } });

    /*
     * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
     * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
     * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
     * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
     * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
     * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
     */
    var IntlTelInputNgModule = /** @class */ (function () {
        function IntlTelInputNgModule() {
        }
        IntlTelInputNgModule.forRoot = function () {
            return {
                ngModule: IntlTelInputNgModule,
                providers: []
            };
        };
        return IntlTelInputNgModule;
    }());
    IntlTelInputNgModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: IntlTelInputNgModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    IntlTelInputNgModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: IntlTelInputNgModule, declarations: [IntlTelInputComponent], imports: [i1.CommonModule,
            i2.FormsModule], exports: [IntlTelInputComponent] });
    IntlTelInputNgModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: IntlTelInputNgModule, imports: [[
                i1.CommonModule,
                i2.FormsModule,
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: IntlTelInputNgModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            IntlTelInputComponent,
                        ],
                        imports: [
                            i1.CommonModule,
                            i2.FormsModule,
                        ],
                        exports: [
                            IntlTelInputComponent,
                        ]
                    }]
            }] });

    /*
     * Public API Surface of intl-tel-input-ng
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.IntlTelInputComponent = IntlTelInputComponent;
    exports.IntlTelInputNgModule = IntlTelInputNgModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=intl-tel-input-ng.umd.js.map
